import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:stateful_provider/process_status.dart';

class ProcessStatusWidget extends StatelessWidget {
  final void Function(dynamic error, void Function() close) error;
  final Widget process;

  ProcessStatusWidget({
    @required this.error,
    this.process = const CircularProgressIndicator(),
  });

  @override
  Widget build(BuildContext context) => Consumer<ProcessStatus>(
        builder: (_, provider, __) {
          final exception = provider.error;
          if (exception != null) {
            WidgetsBinding.instance.addPostFrameCallback((timeStamp) {
              error(exception, () {
                provider.consumeError(exception);
              });
            });
          }
          return provider.isProcessing ? process : Container();
        },
      );
}
